﻿Option Strict On
Imports System.IO.IsolatedStorage
Imports System.IO
Imports Microsoft.Phone.Tasks
Imports System.Xml.Linq
'Imports System.Text
'Imports Microsoft.Xna.Framework

'■■俳句の一覧表示のための、ファイル・リスト用
Public Class ShowYearMonth
    Property 年月 As String
End Class

Partial Public Class CreateHaiku
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub

    '■■季語検索、俳句の入力、翻訳、保存、投稿処理

    '●Microsoft TranslatorのユーザーID●●●取得したIDを指定してください●●●
    Const MyAppID As String = "ユーザーがそれぞれ取得したID"

    '●俳句データを初期化
    Dim MyRuby As String = String.Empty
    Dim MyKuJapanese As String = String.Empty
    Dim MyKuEnglish As String = String.Empty
    Dim MyRecordDateTime As String = String.Empty '登録日時属性値。日英共通でyyyy/MM/dd/HH/mm/ss
    Dim MyComposeHaikuDate As String = String.Empty '創作年月日属性値。○年○月○日

    '●季語検索用キーを初期化
    Dim SearchKigoMonth As String = String.Empty

    '●年月表示を初期化
    Dim CreateHaikuDate As String = String.Empty 'MainPageロード時のタイトル部分の年月表示用

    '●属性値として記録する年月を初期化
    Dim ComposeHaikuMonth As String = String.Empty 'ルート要素｢俳句集」の属性値。○年○月

    '●ファイル名として使う年月を初期化
    Dim CreateHaikuMonth As String = String.Empty 'ComposeHaikuMonthに拡張子.xmlを付加したもの

    '●facebook投稿用データを宣言
    Dim MyPost As String '投稿可の場合True、投稿しない場合False
    Dim MyTitleText As String
    Dim MyLinkText As String

    '■入力ページがロードされた時の処理
    Private Sub CreateHaiku_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        '●タイトル部分に本日の日付を表示。保存時には別途日時を取得する。
        'CreateHaikuDate = DateTime.Now.ToString("yyyy年MM月dd日") '2桁数字の場合
        'CreateHaikuDate = DateTime.Today.ToString("d")'英語版作成時
        CreateHaikuDate = CStr(DateTime.Now.Year) & "年" & CStr(DateTime.Now.Month) & "月" & CStr(DateTime.Now.Day) & "日"
        ShowDate.Text = CreateHaikuDate

        '●季語検索ボタンの2レイヤー目にロード時の月を表示
        'SearchKigoMonth = DateTime.Now.ToString("MM")'2桁数字の場合
        SearchKigoMonth = CStr(DateTime.Now.Month)
        SearchKigoMonthName.Text = SearchKigoMonth

        '●月別俳句ファイルの保存先とする「DailyHaiku_in_Japanese_Data」フォルダがなければ生成しておく
        Dim HaikuStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If HaikuStorage.DirectoryExists("DailyHaiku_in_Japanese_Data") = False Then
            HaikuStorage.CreateDirectory("DailyHaiku_in_Japanese_Data")
        End If

        '●ロード時には俳句ファイルが存在しても月別リストは非表示
        MyHaikuList.Visibility = Windows.Visibility.Collapsed

        '●指定フォルダ内に俳句ファイルがなければ「一覧」ボタンは使用不可とし、1個でもあれば使用可とする
        Dim HaikuFilePath As String = Path.Combine("DailyHaiku_in_Japanese_Data", "*.xml")
        Dim HaikuFileList() As String = HaikuStorage.GetFileNames(HaikuFilePath)
        If HaikuFileList.Length <= 0 Then
            ShowHaikuButton.Opacity = 0.3
            ShowHaikuButton.IsEnabled = False
        Else
            ShowHaikuButton.Opacity = 1.0
            ShowHaikuButton.IsEnabled = True
        End If


        '●facebook投稿用設定ファイルの読み込み。このファイルはPreferences.xaml.vbで生成される。
        Dim Storage_Pre As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim FilePath_Pre As String = Path.Combine("DailyHaiku_Preferences", "MyPreferences.xml")

        '●設定ファイルがあれば、最新の設定データを取得して、投稿可否の判別用変数MyPostにTrueを代入
        If Storage_Pre.FileExists(FilePath_Pre) = True Then

            Dim MyStream_Pre As IsolatedStorageFileStream = Storage_Pre.OpenFile(FilePath_Pre, FileMode.Open, FileAccess.Read)
            Dim Reader_Pre As StreamReader = New StreamReader(MyStream_Pre, System.Text.Encoding.UTF8)
            Dim ReadXmldoc_Pre As String = Reader_Pre.ReadToEnd
            Dim ItemDoc_Pre As XDocument = XDocument.Parse(ReadXmldoc_Pre)
            Reader_Pre.Close()
            MyStream_Pre.Close()

            '●facebook要素を処理して、最後のTitle要素とLinkUri要素の内容を取得、最新の設定データを取得
            Dim MyDataQuery_Pre As IEnumerable(Of XElement) = From c In ItemDoc_Pre.Descendants("facebook") Select c

            For Each MyResult_Pre In MyDataQuery_Pre
                MyTitleText = MyResult_Pre.<Title>.Value
                MyLinkText = MyResult_Pre.<LinkUri>.Value
            Next

            MyPost = "True"
        Else
            '●設定ファイルがなければ、投稿判断用変数MyPostにFalseを代入
            MyPost = "False"
        End If

    End Sub

    '■「英語」ボタンがタップされた時の処理
    Private Sub TranslateButton_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles TranslateButton.Tap

        '●日本語句を取得
        MyKuJapanese = JpnKuBox.Text

        If MyKuJapanese = String.Empty Then
            MessageBox.Show("日本語の俳句を入力してください。")
        End If

        Dim MyWebClient As New WebClient
        Dim MyTranslate As String = String.Format("http://api.microsofttranslator.com/v2/Http.svc/Translate?appId={0}&text={1}&from=ja&to=en", MyAppID, MyKuJapanese)

        MyWebClient.DownloadStringAsync(New Uri(MyTranslate, UriKind.Absolute))

        '●bing翻訳を実行。サーバーからの応答が遅れた場合と、ネットワークに接続されていない場合のエラー処理を書いておく。
        AddHandler MyWebClient.DownloadStringCompleted, Sub(resultSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            Try
                                                                Dim MyTranslateDoc As XDocument = XDocument.Parse(resultArgs.Result)
                                                                EngKuBox.Text = MyTranslateDoc.Elements.First.Value
                                                            Catch
                                                                MessageBox.Show("ネットワークに接続されていないかタイムアウトの可能性があります。しばらくお待ちのうえ翻訳を再実行するか、日本語俳句のみ保存してください。")
                                                                Exit Sub
                                                            End Try
                                                        End Sub
    End Sub

    '■「取消」ボタンがタップされた時の処理
    '●英語俳句入力ボックス内を空にする
    Private Sub ClearButton_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles ClearButton.Tap
        EngKuBox.Text = String.Empty
    End Sub


    '■季語検索
    Private Sub SearchKigo_Tap_1(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles SearchKigo.Tap
        '月をまたぐ場合、「季語検索」ボタンに表示されている、創作開始時点での月の季語を検索
        'SearchKigoMonth = DateTime.Now.ToString("MM月")
        'SearchKigoMonthName.Text = SearchKigoMonth
        Dim MySearchTask As New SearchTask
        MySearchTask.SearchQuery = "俳句 季語 " & SearchKigoMonth & "月"
        MySearchTask.Show()
    End Sub


    '■月別俳句ファイルの生成・保存、facebookへの投稿処理の実行
    Private Sub SaveButton_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles SaveButton.Tap

        '●入力ボックス内のデータを各々変数に代入。英語句とルビが未入力の場合は空データとする
        MyKuJapanese = JpnKuBox.Text
        MyKuEnglish = EngKuBox.Text
        MyRuby = RubyBox.Text

        '●必須項目の「日本語句」が空ではない（入力済み）の場合の処理
        If MyKuJapanese <> String.Empty Then
            Try
                '●データの登録日時を取得（次期英語版のために共通化しておく）
                MyRecordDateTime = DateTime.Now.ToString("yyyy/MM/dd/HH:mm:ss")

                '●保存先フォルダの生成
                Dim HaikuStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
                If HaikuStorage.DirectoryExists("DailyHaiku_in_Japanese_Data") = False Then
                    HaikuStorage.CreateDirectory("DailyHaiku_in_Japanese_Data")
                End If

                '●ファイル名に使用する年月を取得、アクセスするフォルダ名とファイル名を指定
                ComposeHaikuMonth = CStr(DateTime.Now.Year) & "年" & CStr(DateTime.Now.Month) & "月"
                CreateHaikuMonth = ComposeHaikuMonth & ".xml"
                Dim HaikuFilePath As String = Path.Combine("DailyHaiku_in_Japanese_Data", CreateHaikuMonth)

                '●「一覧」表示で、右下に表示する創作年月日を取得
                MyComposeHaikuDate = ComposeHaikuMonth & CStr(DateTime.Now.Day) & "日"

                '●ファイルが存在しない場合は新規生成、存在する場合はデータを末尾に追加
                If HaikuStorage.FileExists(HaikuFilePath) = False Then
                    Dim HaikuXmldoc As XDocument = <?xml version="1.0" encoding="utf-8"?>
                                                   <俳句集 年月=<%= ComposeHaikuMonth %>>
                                                       <俳句 創作年月日=<%= MyComposeHaikuDate %> 登録日時=<%= MyRecordDateTime %>>
                                                           <句><%= MyKuJapanese %></句>
                                                           <ルビ><%= MyRuby %></ルビ>
                                                           <英語句><%= MyKuEnglish %></英語句>
                                                       </俳句>
                                                   </俳句集>
                    Using HaikuStream As IsolatedStorageFileStream = New IsolatedStorageFileStream(HaikuFilePath, FileMode.Create, FileAccess.Write, HaikuStorage)
                        HaikuXmldoc.Save(HaikuStream)
                        MessageBox.Show("今日の俳句を" & ComposeHaikuMonth & "のファイルに保存しました。")
                    End Using

                Else
                    Dim HaikuAddStream As IsolatedStorageFileStream = HaikuStorage.OpenFile(HaikuFilePath, FileMode.Open, FileAccess.Read)
                    Dim HaikuReader As StreamReader = New StreamReader(HaikuAddStream)
                    Dim HaikuReadXmldoc As String = HaikuReader.ReadToEnd
                    Dim HaikuAddDoc As XElement = XElement.Parse(HaikuReadXmldoc)
                    Dim HaikuAddXml As XElement = <俳句 創作年月日=<%= MyComposeHaikuDate %> 登録日時=<%= MyRecordDateTime %>>
                                                      <句><%= MyKuJapanese %></句>
                                                      <ルビ><%= MyRuby %></ルビ>
                                                      <英語句><%= MyKuEnglish %></英語句>
                                                  </俳句>

                    HaikuAddDoc.Add(HaikuAddXml)
                    HaikuAddStream.Dispose()

                    Using HaikuStream As IsolatedStorageFileStream = New IsolatedStorageFileStream(HaikuFilePath, FileMode.Create, FileAccess.Write, HaikuStorage)
                        If HaikuStorage.FileExists(HaikuFilePath) = True Then
                            HaikuAddDoc.Save(HaikuStream)
                            HaikuReader.Dispose()
                            MessageBox.Show("今日の俳句を" & ComposeHaikuMonth & "のファイルに保存しました。")
                        End If
                    End Using

                End If

                '●●facebookへの投稿処理の実行判別

                '●投稿可の場合の処理。ShareLinkTaskを用いて投稿。
                '●投稿しない場合は、MyPostにFalseが代入されているため、この処理はスルーされる

                If MyPost = "True" Then
                        PostToFacebook()
                End If

                '●各入力ボックスを空にし、入力された値を代入する変数を初期化しておく
                RubyBox.Text = String.Empty
                JpnKuBox.Text = String.Empty
                EngKuBox.Text = String.Empty

                MyRuby = String.Empty
                MyKuJapanese = String.Empty
                MyKuEnglish = String.Empty

                '●俳句ファイルが1個でも生成保存されたら、「一覧」ボタンを有効にする
                ShowHaikuButton.Opacity = 1.0
                ShowHaikuButton.IsEnabled = True
            Catch
                Exit Sub
            End Try
        Else
            '●必須の日本語句が空の場合は、メッセージを表示する
            MessageBox.Show("俳句を入力してください。")
            Exit Sub
        End If

    End Sub


    '■facebookへの投稿処理
    Private Sub PostToFacebook()
        '●英語句がある場合、投稿表示を分かりやすくするためスミ付き括弧で囲む
        If MyKuEnglish.Length > 0 Then
            MyKuEnglish = vbCrLf & "【" & MyKuEnglish & "】"
        Else
            MyKuEnglish = String.Empty
        End If

        Try
            Dim MyShareLinkTask As New ShareLinkTask
            With MyShareLinkTask
                .Title = MyTitleText
                .LinkUri = New Uri(MyLinkText, UriKind.Absolute)
                .Message = MyKuJapanese & vbCrLf & MyKuEnglish
                .Show()
            End With
        Catch
            MessageBox.Show("ネットワークへの接続状況を確認してください。あるいは「facebookへの投稿設定」で入力したリンク先URIに不備がないか確認してください。")
            Exit Sub
        End Try
    End Sub


    '■保存済み俳句ファイルの年月リストをListBoxに表示
    Private Sub ShowHaikuButton_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles ShowHaikuButton.Tap

        '●ロード時には非表示状態の、ListBoxを配置したCanvas要素を表示
        MyHaikuList.Visibility = Windows.Visibility.Visible

        '●指定フォルダ内のXMLファイルのリストを取得
        Dim ShowHaikuStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim ShowHaikuFilePath As String = Path.Combine("DailyHaiku_in_Japanese_Data", "*.xml")
        Dim ShowHaikuFileList() As String = ShowHaikuStorage.GetFileNames(ShowHaikuFilePath)

        '●ListBox表示用の年月リストを生成
        Dim ShowHaikuMonthList As New List(Of ShowYearMonth)
        '●ファイル名の拡張子を除く部分を取得、このファイルの冒頭に記述しているShowYearMonthクラスを使い、リストに追加
        For Each MyXmlFileName In ShowHaikuFileList
            ShowHaikuMonthList.Add(New ShowYearMonth With {.年月 = Path.GetFileNameWithoutExtension(MyXmlFileName)})
        Next
        '●年月の追加されたリストを、ListBoxに適用
        MyHaikuMonthListBox.ItemsSource = ShowHaikuMonthList
    End Sub

    '■俳句ファイル・リストのウィンドウをタップした時の処理
    '●ウィンドウを閉じる
    Private Sub MyHaikuList_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles MyHaikuList.Tap
        MyHaikuList.Visibility = Windows.Visibility.Collapsed
    End Sub

    '■ListBoxから、俳句を閲覧したい月が選択された時の処理
    Private Sub MyHaikuMonthListBox_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles MyHaikuMonthListBox.SelectionChanged
        'この処理は、俳句ファイルの削除に共通
        '●このファイルの冒頭に記述しているShowYearMonthクラスを使い、選択されたファイルの項目名（○年○月）を変数SelectedMonthNameに代入
        '●選択されたファイル名（○年○月）をパラメータに保持して、一覧処理ページに移動させる
        Try
            Dim SelectedMonthName As String = DirectCast(MyHaikuMonthListBox.SelectedItem, ShowYearMonth).年月
            NavigationService.Navigate(New Uri("/ShowHaiku.xaml?Name=" & SelectedMonthName, UriKind.Relative))
        Catch
            Exit Sub
        End Try
    End Sub

End Class
