﻿Option Strict On
Imports System.IO.IsolatedStorage
Imports System.IO

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' Constructor
    Public Sub New()
        InitializeComponent()
    End Sub

    '■このページがロードされた時の処理
    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        '●「DailyHaiku_in_Japanese_Data」フォルダがなければ生成しておく
        Dim HaikuStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If HaikuStorage.DirectoryExists("DailyHaiku_in_Japanese_Data") = False Then
            HaikuStorage.CreateDirectory("DailyHaiku_in_Japanese_Data")
        End If

        '●俳句ファイルがあれば削除ボタンを使用可とする
        Dim HaikuFilePath As String = Path.Combine("DailyHaiku_in_Japanese_Data", "*.xml")
        Dim HaikuFileList() As String = HaikuStorage.GetFileNames(HaikuFilePath)
        If HaikuFileList.Length <= 0 Then
            DeleteFileIcon.Opacity = 0.3
            DeleteFileIcon.IsEnabled = False
        Else
            DeleteFileIcon.Opacity = 1.0
            DeleteFileIcon.IsEnabled = True
        End If
    End Sub

    '■タイトルロゴがタップされた時の処理
    Private Sub LogoIcon_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles LogoIcon.Tap
        NavigationService.Navigate(New Uri("/CreateHaiku.xaml?Name=", UriKind.Relative))
    End Sub

    '■「ヘルプ」ボタンがタップされた時の処理
    Private Sub HelpIcon_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles HelpIcon.Tap
        NavigationService.Navigate(New Uri("/DailyHaikuHelp.xaml?Name=", UriKind.Relative))
    End Sub

    '■「設定」ボタンがタップされた時の処理
    Private Sub PreferencesIcon_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles PreferencesIcon.Tap
        NavigationService.Navigate(New Uri("/Preferences.xaml?Name=", UriKind.Relative))
    End Sub

    '■「削除」ボタンがタップされた時の処理
    Private Sub DeleteFileIcon_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles DeleteFileIcon.Tap
        NavigationService.Navigate(New Uri("/DeleteFiles.xaml?Name=", UriKind.Relative))
    End Sub

End Class
